//***********************************************
//*                 Main.C                      *
//***********************************************
//* W402 MPLAB C18 Advance Workshop             *
//* Written by: Richard Yang                    *
//*             Microchip Technology Taiwan     *
//* Date:       12/26 2012                      *
//* Revision:	2                               *
//***********************************************
//*                               mߤ@	
//* 1. N W402 C Workshop rq ROM ŪXܦb LCD ùĤ@m
//* 2. NA^WrܦbĤG檺_lm
//* 3. N@ƥئrq 0  9 ܦb LCD ĤG̫@ӦmAɶ 0.5 Sec
//*	
	
//*           ŧiҨϥΪtJ
//***********************************************************
#include <p18cxxx.h>
#include <delays.h>
#include "P18F_LCD.h"

//*           ƭ쫬ŧi
//***********************************************************
void InitializePORT(void);

//********** Set the Basic Configuration Bits   *********
// OSC used the Internal RC 8MHz, Disable Watch-Dog Timer, Enable Brown-out Reset, Brown-out level = 4.3V,
// Disable Low-voltage Programming, Disable AD input on PORTB, Disable Extented Instruction Set, Enable MCLR Reset
#pragma config OSC=INTIO7, WDT=OFF, BOREN = ON, BORV = 1, LVP=OFF, PBADEN=OFF, XINST = OFF, MCLRE = ON

//*           wqdrܼƨéb Access Bank          
//*********************************************************** 
#pragma idata access My_RAM_1
near char LCD_RAM_MSG[ ]="Richard Yang";
near unsigned char LCD_Char='0';

//*           wqLCDܪdréb ROM      
//*********************************************************** 
#pragma romdata RomData
const rom char LCD_ROM_MSG[ ] ="W402 C Workshop";
#pragma code


//***********************************************************
/*														   */
/* 						Main 	Program					   */
/*														   */
//***********************************************************
void main(void)
{
	OSCCONbits.IRCF = 0x07 ;		// 	Select INTOSC-8Mhz as clock source
									// 	ToDo : iHվ IRCF 줸ӳ]wu@Wv 
	ADCON1bits.PCFG = 0x0f ;		//	Set all ADC multiplexed pins as digital mode

	InitializePORT( );

// } LCD Ҳ
	OpenLCD( );
// b LCD Ĥ@ܦrT"W402 C Workshop"
	LCD_Set_Cursor(0,0);
 	putrsLCD(LCD_ROM_MSG);
// b LCD ĤGܧA^Wr
	LCD_Set_Cursor(1,0);
 	putsLCD(LCD_RAM_MSG);

	while(1)
	{
// ]wܦmbĤG15ӡAܤ@ƥئr(0~9)j0.5
		LCD_Set_Cursor(1,15);
// ƥ Delay10KTCYx(unsigned char)ӧ	
		Delay10KTCYx(100) ;   // (1/8MHz)x4 x10K x100 = 0.5 Sec
// eX 0 ~ 9  LCD ܦr
		putcLCD(LCD_Char++);
// ܼƦrq"0x30" to "0x39", >= 0x3A ܬ 0x30
		if (LCD_Char==0x3A) LCD_Char='0';
	}

}

//************************************************
//*        Function: Initialize PORT             *
//************************************************
void InitializePORT(void)
{
	PORTA=0x00100000;			// RA5 is hi to disable SPI EEPROM if used.
	TRISA=0b11011011;			// RA2 as LCD-E control, RA5 as CS Control for SPI
	
	PORTD=0x00;
	TRISD=0x00;					// Set PORTD as Output port
}
							
#pragma code
